(define-module (ui control facility ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator woo)
	       :export (init))

(define (ui-read-help)
  (catch/message
    (lambda()
      (form-update-value-list '("help")
			      (woo-read-first "/control/facility"
					      'mode (form-value "mode")
					      'name (form-value "name"))))))

(define (ui-read-mode)
  (catch/message
    (lambda()
      (form-update-enum "mode" (woo-list "/control/facility" 'name (form-value "name")))
      (form-update-value-list '("mode")
			      (woo-read-first "/control/facility"
					      'name (form-value "name"))))))

(define (ui-write)
  (catch/message
    (lambda()
      (woo-write
	  "/control/facility"
	  'language (form-value "language")
	  'mode (form-value "mode")
	  'name (form-value "name"))
      (ui-read-mode)
      (form-replace "/control"))))

(define (init)
  (ui-read-mode)
  (ui-read-help)
  (form-bind "mode" "change" ui-read-help)
  (form-bind "apply_button" "click" ui-write))
