(document:surround "/std/frame")

(define (ui-read-help)
  (catch/message
    (lambda()
      (form-update-value-list '("help")
			      (woo-read-first "/control"
					      'mode (form-value "mode")
					      'name (form-value "name"))))))

(define (ui-read-mode)
  (catch/message
    (lambda()
      (form-update-enum "mode" (woo-list "/control/facility" 'name (form-value "name")))
      (form-update-value-list '("mode")
			      (woo-read-first "/control"
					      'name (form-value "name"))))))

(define (ui-write)
  (catch/message
    (lambda()
      (woo-write
	  "/control"
	  'language (form-value "language")
	  'mode (form-value "mode")
	  'name (form-value "name"))
      (ui-read-mode))))

(define (ui-read)
  (ui-read-mode)
  (ui-read-help))

(define (ui-list)
  (let ((facility-list (woo-list "/control")))
    (form-update-enum "name" facility-list)
    (or (null? facility-list)
	(let ((name (woo-get-option (car facility-list) 'name)))
	  (form-update-value "name" name)
	  (ui-read)))))

(gridbox
  margin 20
  columns "20;80"

  ;;
  (listbox colspan 2
	   columns 2
	   name "name"
	   row '#((name . "") (summary . ""))
	   header (vector (_ "Facility") (_ "Summary")))

  ;;
  (label colspan 2)

  ;;
  (separator colspan 2)

  ;;
  (label text (bold (_ "State")) colspan 2)

  ;;
  (listbox name "mode")
  (textbox name "help")

  ;;
  (label colspan 2)

  ;;
  (button text (_ "Apply") align "left" name "apply"))


(document:root
  (when loaded
    (catch/message
      (lambda()
	(ui-list)
	(form-bind "name" "change" ui-read)
	(form-bind "mode" "change" ui-read-help)
	(form-bind "apply" "click" ui-write)))))
